Xvnc(1)

NAME
Xvnc - the X VNC server

SYNOPSIS
Xvnc [options] :display#

DESCRIPTION
Xvnc is the X VNC (Virtual Network Computing) server. It is based on a standard X server, but it has a "virtual" screen rather than a physical one. X applications display themselves on it as if it were a normal X display, but they can only be accessed via a VNC viewer - see vncviewer(1). So Xvnc is really two servers in one. To the applications it is an X server, and to the remote VNC users it is a VNC server. By convention we have arranged that the VNC server display number will be the same as the X server display number, which means you can use eg. snoopy:2 to refer to display 2 on machine "snoopy" in both the X world and the VNC world. The best way of starting Xvnc is via the vncserver script. This sets up the environment appropriately and runs some X applications to get you going. See the manual page for vncserver(1) for more information.

OPTIONS
Xvnc takes lots of options - running Xvnc -help gives a list. Many of these are standard X server options, which are described in the Xserver(1) manual page. In addition to options which can only be set via the command-line, there are also "parameters" which can be set both via the command-line and through the vncconfig(1) program.

-geometry widthxheight
    Specify the size of the desktop to be created. Default is 1024x768.

-depth depth
    Specify the pixel depth in bits of the desktop to be created. Default is 24, other possible values are 16 and 32. Anything else is likely to cause strange behaviour by applications and may prevent the server from starting at all.

-pixelformat format
    Specify pixel format for server to use (BGRnnn or RGBnnn). The default for depth 16 is RGB565 and for depth 24 and 32 is RGB888.

-interface IP address
    Listen on interface. By default Xvnc listens on all available interfaces.

-inetd
    This significantly changes Xvnc's behaviour so that it can be launched from inetd. See the section below on usage with inetd.

-help
    List all the options and parameters

PARAMETERS
VNC parameters can be set both via the command-line and through the vncconfig(1) program, and with a VNC-enabled Xorg server via Options entries in the xorg.conf file. Parameters can be turned on with -param or off with -param=0. Parameters which take a value can be specified as -param value. Other valid forms are param=value -param=value --param=value. Parameter names are case-insensitive.

-desktop desktop-name
    Each desktop has a name which may be displayed by the viewer. It defaults to "x11".

-rfbport port
    Specifies the TCP port on which Xvnc listens for connections from viewers (the protocol used in VNC is called RFB - "remote framebuffer"). The default is 5900 plus the display number.

-UseIPv4
    Use IPv4 for incoming and outgoing connections. Default is on.

-UseIPv6
    Use IPv6 for incoming and outgoing connections. Default is on.

-UnixRelay name:path
    Create a local named unix socket, for relaying data. May be given multiple times. Example: -UnixRelay audio:/tmp/audiosock

-rfbunixpath path
    Specifies the path of a Unix domain socket on which Xvnc listens for connections from viewers, instead of listening on a TCP port.

-rfbunixmode mode
    Specifies the mode of the Unix domain socket. The default is 0600.

-rfbwait time, -ClientWaitTimeMillis time
    Time in milliseconds to wait for a viewer which is blocking the server. This is necessary because the server is single-threaded and sometimes blocks until the viewer has finished sending or receiving a message - note that this does not mean an update will be aborted after this time. Default is 20000 (20 seconds).

-httpd directory
    Run a mini-HTTP server which serves files from the given directory. Normally the directory will contain the kasmweb client. It will use the websocket port.

-http-header header=val
    Append this header to all HTTP responses (file and API). May be given multiple times.

-rfbauth passwd-file, -PasswordFile passwd-file
    Password file for VNC authentication. There is no default, you should specify the password file explicitly. Password file should be created with the vncpasswd(1) utility. The file is accessed each time a connection comes in, so it can be changed on the fly.

-KasmPasswordFile passwd-file
    Password file for BasicAuth, created with the kasmvncpasswd utility. Default ~/.kasmpasswd.

-PublicIP my-ip
    The server's public IP, for UDP negotiation. If not set, will be queried via the internet. Default unset.

-StunServer srv
    Use this STUN server for querying the server's public IP. If not set, a hardcoded list of STUN servers is used. Default unset.

-udpFullFrameFrequency frames
    Send a full frame every N frames for clients using UDP. 0 to disable. Default 0.

-udpPort port
    Which port to use for UDP. Default same as websocket.

-AcceptCutText
    Accept clipboard updates from clients. Default is on.

-SendCutText
    Send clipboard changes to clients. Default is on.

-SendPrimary
    Send the primary selection and cut buffer to the server as well as the clipboard selection. Default is off.

-AcceptPointerEvents
    Accept pointer press and release events from clients. Default is on.

-AcceptKeyEvents
    Accept key press and release events from clients. Default is on.

-AcceptSetDesktopSize
    Accept requests to resize the size of the desktop. Default is on.

-DisconnectClients
    Disconnect existing clients if an incoming connection is non-shared. Default is on. If DisconnectClients is false, then a new non-shared connection will be refused while there is a client active. When combined with NeverShared this means only one client is allowed at a time.

-NeverShared
    Never treat incoming connections as shared, regardless of the client-specified setting. Default is off.

-AlwaysShared
    Always treat incoming connections as shared, regardless of the client-specified setting. Default is off.

-Protocol3.3
    Always use protocol version 3.3 for backwards compatibility with badly-behaved clients. Default is off.

-FrameRate fps
    The maximum number of updates per second sent to each client. If the screen updates any faster then those changes will be aggregated and sent in a single update to the client. Note that this only controls the maximum rate and a client may get a lower rate when resources are limited. Default is 60.

-DynamicQualityMin min
    The minimum quality to with dynamic JPEG quality scaling. The accepted values are 0-9 where 0 is low and 9 is high, with the same meaning as the client-side -quality parameter. Default is 7.

-DynamicQualityMax max
    The maximum quality to use with dynamic JPEG quality scaling. Setting this to zero disables dynamic JPEG quality scaling. The accepted values are 0-9 where 0 is low and 9 is high, with the same meaning as the client-side -quality parameter. Default is 8.

-TreatLossless quality
    Treat lossy quality levels above and including this as lossless, without sending lossless updates for them. 0-9, 10 disables this. Default is 10.

-PreferBandwidth
    Prefer bandwidth over quality, and set various options for lower bandwidth use. The default is off, aka to prefer quality. You can override individual values by setting them after this switch on the command line. This switch sets the following:
    - dynamic JPEG quality range 2-9
    - TreatLossless 8

-RectThreads num
    Use this many threads to compress rects in parallel. Default 0 (automatic), set to 1 to disable.

-JpegVideoQuality num
    The JPEG quality to use when in video mode. Default -1.

-WebpVideoQuality num
    The WEBP quality to use when in video mode. Default -1.

-MaxVideoResolution 1920x1080
    When in video mode, downscale the screen to max this size. Keeps aspect ratio. Default 1920x1080.

-VideoTime seconds
    High rate of change must happen for this many seconds to switch to video mode. Default 5, set 0 to always enable.

-VideoOutTime seconds
    The rate of change must be below the VideoArea threshold for this many seconds to switch out of video mode. Default 3.

-VideoArea percentage
    High rate of change must happen for this % of the screen to switch to video mode. Default 45.

-PrintVideoArea
    Print the detected video area % value. Default off.

-VideoScaling type
    Scaling method to use when in downscaled video mode. 0 = nearest, 1 = bilinear, 2 = progressive bilinear. Default 2.

-CompareFB mode
    Perform pixel comparison on framebuffer to reduce unnecessary updates. Can be either 0 (off), 1 (always) or 2 (auto). Default is 2.

-hw3d
    Enable hardware 3d acceleration. Default is software (llvmpipe usually).

-drinode path
    Use another path instead of /dev/dri/renderD128. You may need this if you have more than one GPU.

-ZlibLevel level
    Zlib compression level for ZRLE encoding (it does not affect Tight encoding). Acceptable values are between 0 and 9. Default is to use the standard compression level provided by the zlib(3) compression library.

-ImprovedHextile
    Use improved compression algorithm for Hextile encoding which achieves better compression ratios by the cost of using slightly more CPU time. Default is on.

-IgnoreClientSettingsKasm
    Ignore the additional client settings exposed in Kasm. Default off. Kasm exposes a few settings to the client the standard VNC does not. This param lets the server ignore those.

-DLP_Region x1,y1,x2,y2
    Black out anything outside this region. x1,y1 is the upper-left corner, and x2,y2 the lower-left. In addition to absolute pixel values, percentages are allowed, zero means "default", and a negative number means "border".

-DLP_RegionAllowClick bool
    Allow clicks inside the blacked-out region.

-DLP_RegionAllowRelease bool
    Allow click releases inside the blacked-out region.

-DLP_ClipSendMax bytes
    Limit clipboard bytes to send to clients in one transaction. Default 0. 0 disables the limit, use SendCutText to disable clipboard sending entirely.

-DLP_ClipAcceptMax bytes
    Limit clipboard bytes to receive from clients in one transaction. Default 0. 0 disables the limit, use AcceptCutText to disable clipboard receiving entirely.

-DLP_ClipDelay ms
    This many milliseconds must pass between clipboard actions. Default 0, 0 disables the limit.

-DLP_ClipTypes a,b
    Allowed binary clipboard mimetypes, separated by commas. Default chromium/x-web-custom-data,text/html,image/png

-DLP_KeyRateLimit keys-per-second
    Reject keyboard presses over this many per second. Default 0 (disabled).

-DLP_Log off/info/verbose
    Log clipboard and keyboard actions. Info logs just clipboard direction and size, verbose adds the contents for both.

-DLP_WatermarkImage path/to/file.png
    Add a watermark. The PNG file should be greyscale, black is treated as transparent and white as opaque.

-DLP_WatermarkLocation x,y
    Place the watermark at this position from the corner. Positive numbers are from top-left, negative from bottom-right. Negative numbers count from the bottom-right edge of the image. If not set, the watermark will be centered. Cannot be used together with repeat.

-DLP_WatermarkRepeatSpace num
    If set, repeat the watermark over the entire image, with num pixels between repetitions. Cannot be used together with location.

-DLP_WatermarkTint r,g,b,a
    Tint the greyscale watermark by this color. Default is 255,255,255,255 - full white. The color components can be used to colorize the greyscale watermark, and the alpha can be used to make it fainter.

-DLP_WatermarkText "foo %H:%M"
    Instead of an image, render this text as the watermark. Takes time formatting options for strftime.

-DLP_WatermarkTextAngle angle
    Rotate the text by this many degrees, increasing clockwise. Default 0.

-DLP_WatermarkFont /path/to/font.ttf
    Use a different font for -DLP_WatermarkText than the bundled one. TTF and OTF fonts are accepted.

-DLP_WatermarkFontSize 48
    Font size for -DLP_WatermarkText. Default 48.

-DLP_WatermarkTimeOffset 0
    Time offset from UTC, hours. Default 0.

-DLP_WatermarkTimeOffsetMinutes 0
    Time offset from UTC, minutes. Default 0.

-selfBench
    Run a set of self-benchmarks and exit.

-noWebsocket
    Disable websockets and expose a traditional VNC port (5901, etc.).

-websocketPort port
    Listen for websocket connections on this port, default 6800.

-cert path
    SSL pem cert to use for websocket connections, default empty/not used.

-key path
    SSL pem key to use for websocket connections, default empty/not used. Only use this if you have the cert and key in separate files. If they are in the same file, use -cert.

-sslOnly
    Require SSL for websocket connections. Default off, non-SSL allowed.

-disableBasicAuth
    Disable basic auth for websocket connections. Default enabled, details read from the -KasmPasswordFile.

-SecurityTypes sec-types
    Specify which security scheme to use for incoming connections. Valid values are a comma separated list of None, VncAuth, Plain, TLSNone, TLSVnc, TLSPlain, X509None, X509Vnc and X509Plain. Default is VncAuth,TLSVnc.

-Password password
    Obfuscated binary encoding of the password which clients must supply to access the server. Using this parameter is insecure, use PasswordFile parameter instead.

-PlainUsers user-list
    A comma separated list of user names that are allowed to authenticate via any of the "Plain" security types (Plain, TLSPlain, etc.). Specify * to allow any user to authenticate using this security type. Default is to deny all users.

-pam_service name, -PAMService name
    PAM service name to use when authentication users using any of the "Plain" security types. Default is vnc.

-X509Cert path
    Path to a X509 certificate in PEM format to be used for all X509 based security types (X509None, X509Vnc, etc.).

-X509Key path
    Private key counter part to the certificate given in X509Cert. Must also be in PEM format.

-GnuTLSPriority priority
    GnuTLS priority string that controls the TLS session’s handshake algorithms. See the GnuTLS manual for possible values. Default is NORMAL.

-BlacklistThreshold count
    The number of unauthenticated connection attempts allowed from any individual host before that host is black-listed. Default is 5.

-BlacklistTimeout seconds
    The initial timeout applied when a host is first black-listed. The host cannot re-attempt a connection until the timeout expires. Default is 10.

-IdleTimeout seconds
    The number of seconds after which an idle VNC connection will be dropped. Default is 0, which means that idle connections will never be dropped.

-MaxDisconnectionTime seconds
    Terminate when no client has been connected for N seconds. Default is 0.

-MaxConnectionTime seconds
    Terminate when a client has been connected for N seconds. Default is 0.

-MaxIdleTime seconds
    Terminate after N seconds of user inactivity. Default is 0.

-QueryConnect
    Prompts the user of the desktop to explicitly accept or reject incoming connections. Default is off. The vncconfig(1) program must be running on the desktop in order for QueryConnect to be supported.

-QueryConnectTimeout seconds
    Number of seconds to show the Accept Connection dialog before rejecting the connection. Default is 10.

-localhost
    Only allow connections from the same machine. Useful if you use SSH and want to stop non-SSH connections from any other hosts.

-Log logname:dest:level
    Configures the debug log settings. dest can currently be stderr, stdout or syslog, and level is between 0 and 100, 100 meaning most verbose output. logname is usually * meaning all, but you can target a specific source file if you know the name of its "LogWriter". Default is *:stderr:30.

-RemapKeys mapping
    Sets up a keyboard mapping. mapping is a comma-separated string of character mappings, each of the form char->char, or char<>char, where char is a hexadecimal keysym. For example, to exchange the " and @ symbols you would specify the following:
    RemapKeys=0x22<>0x40

-AvoidShiftNumLock
    Key affected by NumLock often require a fake Shift to be inserted in order for the correct symbol to be generated. Turning on this option avoids these extra fake Shift events but may result in a slightly different symbol (e.g. a Return instead of a keypad Enter).

-RawKeyboard
    Send keyboard events straight through and avoid mapping them to the current keyboard layout. This effectively makes the keyboard behave according to the layout configured on the server instead of the layout configured on the client. Default is off.

-AllowOverride
    Comma separated list of parameters that can be modified using VNC extension. Parameters can be modified for example using vncconfig(1) program from inside a running session. Allowing override of parameters such as PAMService or PasswordFile can negatively impact security if Xvnc runs under different user than the programs allowed to override the parameters. When NoClipboard parameter is set, allowing override of SendCutText and AcceptCutText has no effect. Default is desktop,AcceptPointerEvents,SendCutText,AcceptCutText,SendPrimary,SetPrimary.

USAGE WITH INETD
By configuring the inetd(1) service appropriately, Xvnc can be launched on demand when a connection comes in, rather than having to be started manually. When given the -inetd option, instead of listening for TCP connections on a given port it uses its standard input and standard output. There are two modes controlled by the wait/nowait entry in the inetd.conf file. In the nowait mode, Xvnc uses its standard input and output directly as the connection to a viewer. It never has a listening socket, so cannot accept further connections from viewers (it can however connect out to listening viewers by use of the vncconfig program). Further viewer connections to the same TCP port result in inetd spawning off a new Xvnc to deal with each connection. When the connection to the viewer dies, the Xvnc and any associated X clients die. This behaviour is most useful when combined with the XDMCP options -query and -once. An typical example in inetd.conf might be (all on one line): 5950 stream tcp nowait nobody /usr/local/bin/Xvnc Xvnc -inetd -query localhost -once securitytypes=none In this example a viewer connection to :50 will result in a new Xvnc for that connection which should display the standard XDM login screen on that machine. Because the user needs to login via XDM, it is usually OK to accept connections without a VNC password in this case. In the wait mode, when the first connection comes in, inetd gives the listening socket to Xvnc. This means that for a given TCP port, there is only ever one Xvnc at a time. Further viewer connections to the same port are accepted by the same Xvnc in the normal way. Even when the original connection is broken, the Xvnc will continue to run. If this is used with the XDMCP options -query and -once, the Xvnc and associated X clients will die when the user logs out of the X session in the normal way. It is important to use a VNC password in this case. A typical entry in inetd.conf might be: 5951 stream tcp wait james /usr/local/bin/Xvnc Xvnc -inetd -query localhost -once passwordFile=/home/james/.vnc/passwd In fact typically, you would have one entry for each user who uses VNC regularly, each of whom has their own dedicated TCP port which they use. In this example, when user "james" connects to :51, he enters his VNC password, then gets the XDM login screen where he logs in in the normal way. However, unlike the previous example, if he disconnects, the session remains persistent, and when he reconnects he will get the same session back again. When he logs out of the X session, the Xvnc will die, but of course a new one will be created automatically the next time he connects.

SEE ALSO
vncconfig(1), vncpasswd(1), vncserver(1), vncviewer(1), Xserver(1), inetd(1)
http://kasmweb.com

AUTHOR
Kasm Technologies Corp., Tristan Richardson, RealVNC Ltd., D. R. Commander and others. VNC was originally developed by the RealVNC team while at Olivetti Research Ltd / AT&T Laboratories Cambridge. TightVNC additions were implemented by Constantin Kaplinsky. Many other people have since participated in development, testing and support. KasmVNC has since forked and the project and has added many modern features and made the solution web native. This manual is part of the KasmVNC software suite.